using System;
using System.Collections.Generic;
using Avalonia.Controls;
using AvaloniaApplication5.Models;
using AvaloniaApplication5.Views;
using Microsoft.EntityFrameworkCore;
using System.Linq;
using ReactiveUI;

namespace AvaloniaApplication5.ViewModels
{
	public class PageUserListViewModel : ReactiveObject
	{
        _1234Context DBConnect;
                
        public PageUserListViewModel(_1234Context dBConnect)
        {
            this.DBConnect = dBConnect;
            userList = DBConnect.Logintables.Include(x => x.IdRoleNavigation).Include(x => x.User.IdGenderNavigation).ToList();
        }
        List<Logintable> userList;
        public List<Logintable> UserList { get => userList; set => this.RaiseAndSetIfChanged(ref userList, value); }
       
        public List<string> OrdersName => new List<string>() { " ", " " };
        string orderByName = " ";
        public string OrderByName
        {
            get => orderByName;
            set
            {
                orderByName = value;
                AllFilters();
            }
        }

        public List<string> Genders//   
        {
            get
            {
                List<string> newlist = new List<string>() { "" };
                newlist.AddRange(DBConnect.Genders.Select(x => x.Gender1).ToList());
                return newlist;
            }
        }
        string filterByGender = "";
        public string FilterByGender
        {
            get => filterByGender;
            set
            {
                filterByGender = value;
                AllFilters();                
            }
        }

        string namefind;
        public string Namefind { get => namefind; set { namefind = value; AllFilters(); } }
        
        void AllFilters()
        {
            //     
            userList = DBConnect.Logintables.Include(x => x.IdRoleNavigation).Include(x => x.User.IdGenderNavigation).ToList();
            //  
            if (!(namefind == "" || namefind == null))
                UserList = UserList.Where(x => x.User.Name.Contains(namefind)).ToList();


            //   
            switch (orderByName)
            {
                case " ":
                    UserList = UserList.OrderBy(x => x.User.Name).ToList();
                    break;
                case " ":
                    UserList = UserList.OrderByDescending(x => x.User.Name).ToList();
                    break;
            }

            //  
            if (!(filterByGender == "" || filterByGender == null))
                UserList = UserList.Where(x => x.User.IdGenderNavigation.Gender1 == filterByGender).ToList();

           
        }

    }
}